#!/System/Index/bin/ruby -w
# Encoding: ISO-8859-1
# =========================================================================== #
require 'pp'
require 'cliner'
require 'colour_e/autoinclude'
require 'ruby_token_parser'

cliner {
  e 'We will next test the '+simp('RubyTokenParser')
}
# =========================================================================== #
# === test_this_string
# =========================================================================== #
def test_this_string(i, optional_argument = nil)
  e 'We will test this input next: '+simp(i)
  x = RubyTokenParser.parse(i, optional_argument)
  pp x
end

_ = '(1..3)'
test_this_string(_)
cliner

_ = "[1,2,3]"
test_this_string(_)
cliner

_ = '(1..5)'
test_this_string(_) # => (1..5)
cliner

_ = 'nil'
test_this_string(_) # => nil
cliner

# =========================================================================== #
# === Handle Symbols
# =========================================================================== #
_ = ':foo'
test_this_string(_) # => :foo
cliner

# =========================================================================== #
# === Handle Integers
# =========================================================================== #
_ = '123'
test_this_string(_) # => 123
cliner

_ = '1.5'
test_this_string(_) # =>  1.5
cliner

_ = '1.5'
test_this_string(_, use_big_decimal: true) # <BigDecimal:…,'0.15E1',18(18)>
cliner

_ = '[1, 2, 3]'
test_this_string(_) # => [1, 2, 3]
cliner

_ = '{:a => 1, :b => 2}'
test_this_string(_) # => {:a => 1, :b => 2}
cliner

_ = '(1..3)'
test_this_string(_) # => (1..3)
cliner

_ = '"xyz"'
test_this_string(_) # => 
cliner